#!/bin/sh

#===================================	README	==============================
#	This is the global script to that runs the tests in rtlinux-tests
#	directory , the tests to be run can be choosen by command line
#	parameters 
#	Pease use ./run_tests.sh  help for more details  
#==============================================================================

CUR_DIR=`pwd`
export SCRIPTS_DIR=${CUR_DIR%rtlinux-tests*}rtlinux-tests/scripts

source $SCRIPTS_DIR/setenv.sh

loop=0

function run_in_loop() {
	for ((i=0; i<loop; i++))
	do
		run_once $1
	done
#	while true ; do run_once $1 ; done ; #Need to improve this
}

function run_once() {
	local tests
	tests=`echo "$1"`
	for element in $1
	do
		cd $RTLINUX_DIR
		SUBDIR=`find -name $element`
                if [ -z "$SUBDIR" ];then
                        echo " $element is not a valid test-case "
		else
			for subdir in `find -name $element`
			do 
				
				if [  -d "$subdir" ];then
					cd $subdir
					exec_run_auto
					cd $RTLINUX_DIR 
				fi
			done
		fi
	done
	
}
function exec_run_auto()
{
	#run all run_auto.sh in the subdir's of current dir
	for file in `find -name run_auto.sh`
	do
		dir_name=`dirname $file`
		cd $dir_name
		./run_auto.sh
		echo "======================= finished====================="
		cd -
	done
}
function list_useage()
{

		echo -e "\nUsage : $0 tests=sched_latency,stress,.. forever "
		echo -e "Type $0 help for more help\n "
		exit 1 ;
}

	if [ -z "$*" ] ; then
		list_useage
	fi


cd $TESTS_DIR
for arg in $*;
do
	opt=( `echo $arg | cut -d= --output-delimiter=" " -f1,2` )
	case ${opt[0]} in
		tests)
			if [ ! -z ${opt[1]} ]; then
				test_case=(`echo ${opt[1]} | cut -d, --output-delimiter=" " -f- `)		
			fi			
				;;
		help)
			echo "												"
			echo " Usage: $0 [tests[forever] | all | list | help]						"
			echo "												"
			echo " 		tests=[func|,stress|,pi-tests|,calibrate]					"
			echo "					$0 list lists the available directory's user can choose	"
			echo "					any directory in the hiearchy of listed files		"
			echo "												"
			echo "		list			lists the available directory's , user can choose	" 
			echo "					any directory in the hiearchy of listed files		"
			echo "												"
			echo " 		help			help on $0						"
			echo "												"
		 	echo "		loop=[n]		runs the specified test suite in a loop			"
			echo "												"
			echo " 		all 			runs all the tests in rtlinux-tests			"
			echo "												"
			#Need to add options to run the tests sequentially/parallely	
			exit
			;;
		loop)
			if [ ! -z ${opt[1]} ]; then
				loop=(`echo ${opt[1]} | cut -d, --output-delimiter=" " -f- `)		
			fi	
			;;
		list)
			#list the test-cases available 
			cd $TESTS_DIR
			for file in `find -name run_auto.sh`
			do
				echo "`dirname	$file `"
			done
			exit 
			;;

		all) test_case=rtlinux-tests	
			
			;;
	esac
done

	argument=`echo ${test_case[@]}`
	if [ -z "$argument" ]; then
		list_useage 
	fi

#check if machine has access to internet, which is required for pounder
	read -p "Does the system have access to internet? (y/n):" INTERNET
	if [ $INTERNET = "n" ]; then
		telnet kernel.beaverton.ibm.com 2>> $LOG_DIR/Error_Log
		ping -c 1 kernel.beaverton.ibm.com >& /dev/null
		if [ $? -gt 0 ]; then
			echo "pounder will not be run as failed to ping kbic!!"
			KBIC=n;
		else
			KBIC=y;
			$SCRIPTS_DIR/ssh-keygen.sh kernel.beaverton.ibm.com
			if [ "$?" -ne 0 ] ; then
				echo " ssh-key generation failed, exiting "
				exit 1
			fi
			read kbic_uid < uid
			rm -rf uid
			echo "kbic_uid=$kbic_uid" >> scripts/setenv.sh
        	fi
	fi

	echo "export INTERNET=$INTERNET" >> scripts/setenv.sh
	echo "export KBIC=$KBIC" >> scripts/setenv.sh

	>$TESTS_DIR/scripts/known_hosts
	if [ $loop -ne 0 ] ; then
		run_in_loop "$argument"
	else	
		run_once  "$argument"
	fi
